%--------------------------------------------------------------------------
%               Systems and control theory
%               Prof: Luigi Biagiotti
%               Solution of exercises #9b
%--------------------------------------------------------------------------
clear all
close all
clc

m = 1;      % Kg
k0= 0.5; k1 = 0.25;   % N/m
b= 0.75;    % M*s/m

x0 = 0;
dx0 = 0;

%% 1st point. In the  simulink sile MassNonlinearSpringSystem_mdl

%% 2nd point.

F0=3;
%xe = [0; 2];
[xe,ue,ye,dxe] = trim('MassNonlinearSpringSystem_mdl',[],F0,[],[],1,[])
[A,B,C,D]=linmod('MassNonlinearSpringSystem_mdl',xe,ue);
eig(A)
LinSys = ss(A,B,C,D);


%% 3rd point.

x0 = xe(2);
dx0 = xe(1);
X0sl=[0 0]';
sim('MassNonlinearSpringSystemResponse_mdl',10)
figure
plot(time,dx)
hold on
grid on
plot(time,dxsl,'r--')
legend('Nonlinear system','Linearized system')
xlabel('time')
ylabel('dx')